#include <set>
#include <stack>
#include <queue>
#include <math.h>
#include <vector>
#include <stdio.h>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <time.h>

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define Ri(a) scanf("%d", &a)
#define Ri2(a,b) scanf("%d%d", &a, &b)
#define Wi(a) printf("%d ", a)
#define Wi2(a,b) printf("%d %d ", a, b)
#define Wie(a) printf("%d\n", a)
#define Wie2(a,b) printf("%d %d\n", a, b)
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR( i, 0, (n) - 1 )
#define ll long long
#define pii pair< int, int >

using namespace std;

bool used[10010];
int n, m;
vector < int > gr[10010];
vector < pii > comp;

queue < int > q;

bool sr( pii a, pii b ) {
     return abs( a.F - a.S ) > abs( b.F - b.S );
}

void getcomp( int v ) {
     q.push( v );
     used[v] = 1;
     
     int f = 0, s = 0, sz;
     
     while( 1 ) {
            sz = q.size();
            if( sz == 0 ) break;
            forn( i, sz ) {
                  v = q.front();
                  //cout << v << endl;
                  f++;
                  q.pop();
                  forn( j, gr[v].size() ) {
                        if( used[ gr[v][j] ] == 0 ) used[ gr[v][j] ] = 1, q.push( gr[v][j] );
                  }
            }
            swap( f, s );
     }
     
     comp.pb( mp( min(f, s), max(f, s) ) );
}

int main() {
    freopen("roads.in", "r", stdin);
    freopen("roads.out", "w", stdout);
    
    int x, y;
    Ri2( n, m );
    forn( i, m ) {
          Ri2( x, y );
          x--, y--;
          gr[x].pb( y );
          gr[y].pb( x );
    }
    memset( used, 0, n );
    
    forn( i, n ) {
          //cout << i << endl;
          if( used[i] == 0 ) getcomp( i );
    }
    
    sort( &comp[0], &comp[comp.size()], sr );
    
    int f = 0, s = 0, mx;
    
    forn( i, comp.size() ) {
          if( f > s ) swap( f, s );
          
          f += comp[i].S;
          s += comp[i].F;
    }
    mx = f * s - m;
    
    srand( time(0) );
    while( clock() < 2990 ) {
           f = 0, s = 0;
           random_shuffle( &comp[0], &comp[comp.size()] );
           
           forn( i, comp.size() ) {
                 if( f > s ) swap( f, s );
          
                 f += comp[i].S;
                 s += comp[i].F;
          }
          mx = max( mx, f*s - m );
    }
    //////
    cout << mx << endl;
    
    fclose(stdout);
    fclose(stdin);
    return 0;
}
