#include <stdio.h>
#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;
int n,m;
int color[10000],cl,ucl[3];
int ans;
vector<int> G[10000];

void bfs(int V)
{    
     queue< pair<int,int> > Q;
     Q.push(make_pair(V,cl));
     while (!Q.empty())
           {
               int v;
               v=Q.front().first; cl=Q.front().second; Q.pop();
               color[v]=cl; ucl[cl]++;
               for (int i=0;i<G[v].size();i++) 
                   if (color[G[v][i]]==0) {Q.push(make_pair(G[v][i],3-cl));}           
                       } 
     }

void connect(int V)
{
     int i;
     int connected[10000]={0}; connected[V]=1;
     for (i=0;i<G[V].size();i++) connected[G[V][i]]=1;
     for (i=0;i<n;i++) 
         if (connected[i]==0) 
            if (color[i]==3-color[V])
               {ans++; G[V].push_back(i); G[i].push_back(V);}
     }

int main() {
    int i;
    freopen("roads.in","r",stdin); 
    freopen("roads.out","w",stdout);
    scanf("%d%d",&n,&m);
    for (i=0;i<m;i++)
        {
        int x,y;
        scanf("%d%d",&x,&y); x--; y--;
        G[x].push_back(y); G[y].push_back(x);
        }
    cl=1;
    for (i=0;i<n;i++) if (color[i]==0) { 
        if (ucl[cl]>ucl[3-cl]) cl=3-cl; bfs(i);}
    //for (i=0;i<n;i++) {printf("Vertex=%d Color=%d\n",i+1,color[i]);}
    for (i=0;i<n;i++) connect(i);
    
    printf("%d\n",ans);
    fclose(stdin);
    fclose(stdout);   
    return 0;
}
