#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <algorithm>
#include <cmath>
#define LONG unsigned long long
#define Long unsigned long

using namespace std;

LONG N, K;
vector<Long> A;
Long maxA = 0;

inline void Input()
{
    stringstream ss;
    ifstream fin("transit.in");
    ss<<fin.rdbuf();
    fin.close();

    ss>>N>>K;
    A.resize(N);

    for(Long i = 0; i < N; i++)
    {
        ss>>A[i];
        if(A[i] > maxA)
            maxA = A[i];
    }
}

inline Long BinarySearch(Long begin, Long end)
{
    while(begin != end - 1)
    {
        Long cursor = (begin + end)/2;
        LONG sum = 0;
        for(Long i = 0; i < N; i++)
        {
            if(cursor < A[i])
                sum += A[i] - cursor;
        }
        if(sum >= K)
            begin = cursor;
        else
            end = cursor;
    }
    return begin;
}

int main()
{
    Input();

    ofstream fout("transit.out");
    Long answer = BinarySearch(0, maxA);
    fout<<answer<<endl;
    fout.close();

    return 0;
}
